<?php
/**
 *
 * SIMPLE Journal-to-feed converter
 *
 * This script converts any DimensioneX game's journal (plain text format, proprietary) into a standard RSS feed.
 * The resulting RSS feed can be then piped via twitterfeed.com or hootsuite.com for great Web 2.0 reuse (Facebook pages, Twitter, you name it)
 *
 * Version 1.0 SIMPLE
 *
 * For DimensioneX 6.4.9 or later
 *
 * http://www.dimensionex.net
 *
 * NOTICE ON THIS SOFTWARE
 *
 * License: GPL 2.0, Open Source, feel free to share
 * Guarantees: None, use at your own risk
 *
 */


// CONFIG HERE
$gamewebsite = 'http://www.gamesite.net/'; // URL to game's official web site (used in RSS feed)
$gamedescr = 'Your great MMORPG game'; // (brief)  game description to be used in game RSS feed
$journalfile = '../private/journal.txt'; // Path to journal file. Can be relative. Does NOT need to be accessible via web (better not).
$feedtitle = 'MMORPG Game Feed'; // Human-readable title for Game events RSS Feed
$feedurl = 'http://www.gamesite.net/grss.php'; // URL to Game events RSS Feed
$debugmode = FALSE; // Set to TRUE to see diagnostic messages
// STOP CONFIG!

header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Pragma: no-cache");

if ($debugmode) {
	echo '<!doctype html>
	<html xmlns:fb="http://www.facebook.com/2008/fbml">
	';
} else {
 	echo '<?xml version="1.0" encoding="UTF-8"?>'."\n";
 }


error_reporting(0); // Disable session warnings

?>
<rss version="2.0"
	xmlns:content="http://purl.org/rss/1.0/modules/content/"
	xmlns:wfw="http://wellformedweb.org/CommentAPI/"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:atom="http://www.w3.org/2005/Atom"
	xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"
	xmlns:slash="http://purl.org/rss/1.0/modules/slash/"
	>

<channel>
	<title><?php echo $feedtitle; ?></title>
	<atom:link href="<?php echo $feedurl; ?>" rel="self" type="application/rss+xml" />
	<link><?php echo $gamewebsite; ?></link>
	<description><?php $gamedescr; ?></description>
<?php
	if (!file_exists($journalfile)) { 
		echo "Journal file: '$journalfile' does not exist"; 
		exit(); 
	}

	$mtime = filemtime($journalfile);
	$gmdate_mod = gmdate('D, d M Y H:i:s O', $mtime);
	
	echo "	<lastBuildDate>$gmdate_mod</lastBuildDate>
	<language>en</language>
	<sy:updatePeriod>hourly</sy:updatePeriod>
	<sy:updateFrequency>1</sy:updateFrequency>
";

	$file_handle = fopen($journalfile, "rb");

	while (!feof($file_handle) ) {

		$line_of_text = fgets($file_handle);
		if ($line_of_text) {
			$parts = explode('|', $line_of_text);

			if (count($parts)>3) {
				$p = $parts[3];
				
				/*
				$desc = $p;
				foreach(mb_list_encodings() as $chr){
						echo mb_convert_encoding($desc, 'UTF-8', $chr)." : ".$chr."\n";
				} 
				*/
				
				$p = mb_convert_encoding($p, 'UTF-8', 'ISO-8859-1');
				$p = str_replace('\n',"<br />\n",$p);
				$whatplain = strip_tags($p);
				
				$link = strip_tags($parts[2]);
				if ($link != $parts[2] || !$link) $link = $gamewebsite; // Sanitize
				
				$ititle = mb_convert_encoding($parts[1], 'UTF-8', 'ISO-8859-1');
				if (($ititle != $prevititle) && ($whatplain != $prevplain)) { // Avoid double lines
					print "<item>
				<title>$ititle</title>
				<link>{$link}</link>
				<pubDate>{$parts[0]}</pubDate>
				<description><![CDATA[$whatplain]]></description>
					<content:encoded><![CDATA[{$p}]]></content:encoded>

				";
				
					$cats = explode('*', trim($parts[4])); // Try separating categories with *
					if (count($cats)<2) // Zero or one categories. Try separating with commas
						$cats = explode(',', trim($parts[4]));
					foreach ($cats as $c) {
						echo "<category><![CDATA[$c]]></category>\n";
					}
					print "</item>\n";
				}
				$prevtitle = $ititle;
				$prevplain = $whatplain;
			}
		}
	}

	fclose($file_handle);	



?>
	</channel>
</rss>
